Object.defineProperty(exports, "__esModule", { value: true });
var state_1 = require("./state");
var ActionTypes_1 = require("./ActionTypes");
var Phases_1 = require("./Phases");
function reducer(state, action, isSceneAction) {
    if (state === void 0) { state = state_1.default; }
    if (!isSceneAction)
        return state;
    switch (action.type) {
        case ActionTypes_1.default.ARENA_SCENE_ANIMATION_NEXTPHRASE:
            if (state.phase !== action.phase)
                return state;
            switch (state.phase) {
                case Phases_1.default.LOADING:
                    return Object.assign({}, state, {
                        phase: Phases_1.default.ENTERING
                    });
                case Phases_1.default.ENTERING:
                    return Object.assign({}, state, {
                        phase: Phases_1.default.IN
                    });
                case Phases_1.default.LEAVING:
                    return Object.assign({}, state, { phase: Phases_1.default.OUT });
                default:
                    return state;
            }
        case ActionTypes_1.default.ARENA_SCENE_ANIMATION_LEAVING_START:
            if (state.phase === Phases_1.default.IN)
                return Object.assign({}, state, { phase: Phases_1.default.LEAVING });
        default:
            return state;
    }
}
exports.default = reducer;
